/* 
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 151
 * Usage: Ocean - operational
 */ 

TBLE2 ecmwf_151_params[] = {
{1, "Accumulated potential temperature", "deg C", "APT"},
{2, "Accumulated salinity", "psu", "AS"},
{3, "Accumulated U velocity", "m s**-1", "AU"},
{4, "Accumulated V velocity", "m s**-1", "AV"},
{5, "Accumulated W velocity", "m s**-1", "AWV"},
{6, "Accumulated modulus of strain rate tensor", "s**-1", "AMST"},
{7, "Accumulated vertical viscosity", "m**2 s**-1", "AVVS"},
{8, "Accumulated vertical diffusivity", "m**2 s**-1", "AVDF"},
{9, "Accumulated depth", "m", "ADEP"},
{10, "Accumulated sigma-theta", "kg m**-3", "ASTH"},
{11, "Accumulated Richardson number", "-", "ARN"},
{12, "Accumulated U*V product", "m**2 s**-2", "AUV"},
{13, "Accumulated U*T product", "m s**-1 deg C", "AUT"},
{14, "Accumulated V*T product", "m s**-1 deg C", "AVT"},
{15, "Accumulated U*U product", "m**2 s**-2", "AUU"},
{16, "Accumulated V*V product", "m**2 s**-2", "AVV"},
{17, "Accumulated sea level", "m", "ASL"},
{19, "Accumulated barotropic stream function", "m**3 s**-1", "ABSF"},
{20, "Accumulated mixed layer depth", "m", "AMLD"},
{25, "Accumulated U stress", "Pa", "ATAX"},
{26, "Accumulated V stress", "Pa", "ATAY"},
{27, "Accumulated turbulent kinetic energy input", "W m**-2", "ATKI"},
{28, "Accumulated net surface heat flux", "W m**-2", "ANSF"},
{29, "Accumulated absorbed solar radiation", "W m**-2", "AASR"},
{30, "Accumulated precipitation - evaporation", "m s**-1", "APME"},
{31, "Accumulated specified sea surface temperature", "deg C", "ASST"},
{32, "Accumulated specified surface heat flux", "W m**-2", "ASHF"},
{33, "Accumulated diagnosed sea surface temperature", "deg C", "ADTE"},
{34, "Accumulated heat flux correction", "W m**-2", "AHFC"},
{129, "Ocean potential temperature", "deg C", "OCPT"},
{130, "Salinity", "psu", "S"},
{131, "U velocity", "m s**-1", "U"},
{132, "V velocity", "m s**-1", "V"},
{133, "W velocity", "m s**-1", "WV"},
{134, "Modulus of strain rate tensor", "s**-1", "MST"},
{135, "Vertical viscosity", "m**2 s**-1", "VVS"},
{136, "Vertical diffusivity", "m**2 s**-1", "VDF"},
{137, "Depth", "m", "DEP"},
{138, "Sigma-theta", "kg m**-3", "STH"},
{139, "Richardson number", "-", "RN"},
{145, "Sea level", "m", "SL"},
{146, "Sea level previous timestep", "m", "SL_1"},
{147, "Barotropic stream function", "m**3 s**-1", "BSF"},
{148, "Mixed layer depth", "m", "MLD"},
{153, "U stress", "Pa", "TAX"},
{154, "V stress", "Pa", "TAY"},
{155, "Turbulent kinetic energy input", "W m**-2", "TKI"},
{156, "Net surface heat flux", "W m**-2", "NSF"},
{157, "Absorbed solar radiation", "W m**-2", "ASR"},
{158, "Precipitation - evaporation", "m s**-1", "PME"},
{159, "Specified sea surface temperature", "deg C", "SST"},
{160, "Specified surface heat flux", "W m**-2", "SHF"},
{161, "Diagnosed sea surface temperature error", "deg C", "DTE"},
{162, "Heat flux correction", "W m**-2", "HFC"},
{163, "20 degrees isotherm depth", "m", "20D"},
{164, "Average potential temperature in the upper 300m", "degrees C", "TAV300"},
{167, "Vertically integrated zonal volume transport", "m**2 s**-1", "ZTR"},
{168, "Vertically integrated meridional volume transport", "m**2 s**-1", "MTR"},
{169, "Vertically integrated zonal heat transport", "J m**-1 s**-1", "ZHT"},
{170, "Vertically integrated meridional heat transport", "J m**-1 s**-1", "MHT"},
{171, "U velocity maximum", "m s**-1", "UMAX"},
{172, "Depth of the velocity maximum", "m", "DUMAX"},
{173, "Salinity maximum", "psu", "SMAX"},
{174, "Depth of salinity maximum", "m", "DSMAX"},
{175, "Average salinity in the upper 300m", "psu", "SAV300"},
{178, "Potential temperature increment", "deg C", "PTI"},
{179, "Potential temperature analysis error", "deg C", "PTAE"},
{180, "Background potential temperature", "deg C", "BPT"},
{181, "Analysed potential temperature", "deg C", "APT"},
{182, "Potential temperature background error", "deg C", "PTBE"},
{183, "Analysed salinity", "psu", "AS"},
{184, "Salinity increment", "psu", "SALI"},
};
