/* 
 * European Centre for Medium-Range Weather Forecasts: Reading
 * Center: 98
 * Subcenter: 0
 * Parameter table version: 190
 * Usage:  Development of a European Multi model Ensemble system for seasonal to inter annual prediction (DEMETER) - Provisional
 */ 

TBLE2 ecmwf_190_params[] = {
{34, "Sea surface temperature", "K", "SSTK"},
{129, "Geopotential", "m**2 s**-2", "Z"},
{130, "Temperature", "K", "T"},
{131, "U velocity", "m s**-1", "U"},
{132, "V velocity", "m s**-1", "V"},
{133, "Specific humidity", "kg kg**-1", "Q"},
{139, "Surface temperature", "K", "STL1"},
{141, "Snow depth", "m of water", "SD"},
{151, "Mean sea level pressure", "Pa", "MSL"},
{164, "Total cloud cover", "[0 - 1)]", "TCC"},
{165, "10 metre U wind component", "m s**-1", "10U"},
{166, "10 metre V wind component", "m s**-1", "10V"},
{167, "2 metre temperature", "K", "2T"},
{168, "2 metre dewpoint temperature", "K", "2D"},
{169, "Surface solar radiation downwards", "W s m**-2", "SSRD"},
{170, "Field capacity", "?", "CAP"},
{171, "Wilting points", "?", "WILT"},
{172, "Land-sea mask", "[0.0 - 1.0]", "LSM"},
{173, "Surface roughness length", "[0.0 - 1.0]", "SR"},
{174, "Albedo", "[0.0 - 1.0]", "AL"},
{175, "Surface longwave radiation downwards", "W s m**-2", "STRD"},
{176, "Surface net solar radiation", "W s m**-2", "SSR"},
{177, "Surface net longwave radiation", "W s m**-2", "STR"},
{178, "Top net solar radiation", "W s m**-2", "TSR"},
{179, "Top net longwave radiation", "W s m**-2", "TTR"},
{228, "Total precipitation", "m", "TP"},
{229, "Total soil moisture", "m (kg?)", "TSM"},
};
