/* 
 * US National Weather Service - NCEP (WMC)
 * Center: 7
 * Subcenter: 0 
 * Parameter table version: 128
 * Usage: Ocean Modeling Branch
 */ 

TBLE2 omb_params[] = {
{2, "6.6 GHz", "K", "GHZ6"},
{3, "10.7 GHz", "K", "GHZ10"},
{4, "18.0 GHz", "K", "GHZ18"},
{5, "SSMI 19 GHz, Vertical Polarization", "K", "GHZ19V"},
{6, "SSMI 19 GHz, Horizontal Polarization", "K", "GHZ19H"},
{7, "21.0 GHz", "K", "GHZ21"},
{8, "SSMI 22 GHz, Vertical Polarization", "K", "GHZ22V"},
{9, "SSMI 37 GHz, Vertical Polarization", "K", "GHZ37V"},
{10, "SSMI 37 GHz, Horizontal Polarization", "K", "GHZ37H"},
{11, "MSU Ch 1 - 50.30 GHz", "K", "MSU1"},
{12, "MSU Ch 2 - 53.74 GHz", "K", "MSU2"},
{13, "MSU Ch 3 - 54.96 GHz", "K", "MSU3"},
{14, "MSU Ch 4 - 57.95 GHz", "K", "MSU4"},
{15, "SSMI 85 GHz, Vertical Polarization", "K", "GHZ85V"},
{16, "SSMI 85 GHz, Horizontal Polarization", "K", "GHZ85H"},
{17, "91.65 GHz", "K", "GHZ91"},
{18, "150 GHz", "K", "GHZ150"},
{19, "183 +- 7 GHz", "K", "GHZ183PM7"},
{20, "183 +- 3 GHz", "K", "GHZ183PM3"},
{21, "183 +- 1 GHz", "K", "GHZ183PM1"},
{22, "SSM/T1 - ch 1", "K", "SSMT1C1"},
{23, "SSM/T1 - ch 2", "K", "SSMT1C2"},
{24, "SSM/T1 - ch 3", "K", "SSMT1C3"},
{25, "SSM/T1 - ch 4", "K", "SSMT1C4"},
{26, "SSM/T1 - ch 5", "K", "SSMT1C5"},
{27, "SSM/T1 - ch 6", "K", "SSMT1C6"},
{28, "SSM/T1 - ch 7", "K", "SSMT1C7"},
{60, "HIRS/2 ch 1 - 14.95 micron", "K", "MI14_95"},
{61, "HIRS/2, GOES 14.71 micron", "K", "MI14_71"},
{62, "HIRS/2 ch 3 - 14.49 micron", "K", "MI14_49"},
{63, "GOES I-M - 14.37 micron", "K", "MI14_37"},
{64, "HIRS/2 ch 4 - 14.22 micron", "K", "MI14_22"},
{65, "GOES I-M - 14.06 micron", "K", "MI14_06"},
{66, "HIRS/2 ch 5 - 13.97 micron", "K", "MI13_97"},
{67, "HIRS/2, GOES 13.64 micron", "K", "MI13_64"},
{68, "GOES I-M - 13.37 micron", "K", "MI13_37"},
{69, "HIRS/2 ch 7 - 13.35 micron", "K", "MI13_35"},
{70, "GOES I-M - 12.66 micron", "K", "MI12_66"},
{71, "GOES I-M - 12.02 micron", "K", "MI12_02"},
{72, "AVHRR ch 5 - 12.0 micron", "K", "MI12_00"},
{73, "HIRS/2 ch 8 - 11.11 micron", "K", "MI11_11"},
{74, "GOES I-M - 11.03 micron", "K", "MI11_03"},
{75, "AVHRR ch 4 - 10.8 micron", "K", "MI10_80"},
{76, "HIRS/2, GOES - 9.71 micron", "K", "MI9_71"},
{80, "HIRS/2 ch 10 - 8.16 micron", "K", "MI8_16"},
{81, "GOES I-M - 7.43 micron", "K", "MI7_43"},
{82, "HIRS/2 ch 11 - 7.33 micron", "K", "MI7_33"},
{83, "GOES I-M - 7.02 micron", "K", "MI7_02"},
{84, "HIRS/2 ch 12 - 6.72 micron", "K", "MI6_72"},
{85, "GOES I-M - 6.51 micron", "K", "MI6_51"},
{86, "HIRS/2, GOES - 4.57 micron", "K", "MI4_57"},
{87, "HIRS/2, GOES - 4.52 micron", "K", "MI4_52"},
{88, "HIRS/2 ch 15 - 4.46 micron", "K", "MI4_46"},
{89, "GOES I-M - 4.45 micron", "K", "MI4_45"},
{90, "HIRS/2 ch 16 - 4.40 micron", "K", "MI4_40"},
{91, "HIRS/2 ch 17 - 4.24 micron", "K", "MI4_24"},
{92, "GOES I-M - 4.13 micron", "K", "MI4_13"},
{93, "HIRS/2 ch 18 - 4.00 micron", "K", "MI4_00"},
{94, "GOES I-M - 3.98 micron", "K", "MI8_16"},
{95, "HIRS/2 Window - 3.76 micron", "K", "MI8_16"},
{96, "AVHRR, GOES - 3.74 micron", "K", "MI8_16"},
{100, "AVHRR ch 2 - 0.91 micron", "K", "MI0_91"},
{101, "GOES I-M - 0.696 micron", "K", "MI0_696"},
{102, "HIRS/2 Vis - 0.69 micron", "K", "MI0_69"},
{103, "AVHRR ch 1 - 0.63 micron", "K", "MI0_63"},
{128, "Ocean depth - mean", "m", "AVDEPTH"},
{129, "Ocean depth - instantaneous", "m", "DEPTH"},
{130, "Ocean surface elevation relative to geoid", "m", "ELEV"},
{131, "Max ocean surface elevation in last 24 hours", "m", "MXEL24"},
{132, "Min ocean surface elevation in last 24 hours", "m", "MNEL24"},
{135, "Oxygen", "Mol/kg", "O2"},
{136, "PO4", "Mol/kg", "PO4"},
{137, "NO3", "Mol/kg", "NO3"},
{138, "SiO4", "Mol/kg", "SIO4"},
{139, "CO2 (aq)", "Mol/kg", "CO2AQ"},
{140, "HCO3", "Mol/kg", "HCO3"},
{141, "CO3", "Mol/kg", "CO3"},
{142, "TCO2", "Mol/kg", "TCO2"},
{143, "TALK", "Mol/kg", "TALK"},
{146, "S11 - 1,1 component of ice stress tensor", "unknown", "S11"},
{147, "S12 - 1,2 component of ice stress tensor", "unknown", "S12"},
{148, "S22 - 2,2 component of ice stress tensor", "unknown", "S22"},
{149, "T1 - First invariant of stress tensor", "unknown", "INV1"},
{150, "T2 - Second invariant of stress tensor", "unknown", "INV2"},
{155, "Wave Roughness", "unknown", "WVRGH"},
{156, "Wave Stresses", "unknown", "WVSTRS"},
{157, "Whitecap coverage", "unknown", "WHITE"},
{158, "Swell direction width", "unknown", "SWDIRWID"},
{159, "Swell frequency width", "unknown", "SWFREWID"},
{160, "Wave age", "unknown", "WVAGE"},
{161, "Physical Wave age", "unknown", "PWVAGE"},
{165, "Master length scale (turbulence)", "m", "LTURB"},
{170, "Net Air-Ice heat flux", "W/m^2", "AIHFLX"},
{171, "Net Air-Ocean heat flux", "W/m^2", "AOHFLX"},
{172, "Net Ice-Ocean heat flux", "W/m^2", "IOHFLX"},
{173, "Net Ice-Ocean salt flux", "kg/s", "IOSFLX"},
{175, "Ocean Mixed Layer Temperature", "K", "OMLT"},
{176, "Ocean Mixed Layer Salinity", "kg/kg", "OMLS"},
{178, "Ocean mixed layer u velocity", "m/s", "OMLU"},
{179, "Ocean mixed layer v velocity", "m/s", "OMLV"},
{254, "Relative Error Variance", "non-dim", "REV"},
};
